// Attetntion: There can't be more then one popup at one time

// DOM manipulation library
var $4 = {
	// Get html element by id
	// @param {String} id
	// @return {HTMLElement} 
	id: function(id){
		return document.getElementById(id);
	},
	// @param {string} text
	// @return {TextNode}
	t: function(text){
		return document.createTextNode(text);
	},
	// Create new HTML Element with options
	// @param {_} - First is Tag name <) console.dir($4.cr("option","value","email","textContent","Hello")); 
	// @return {HTMLElement}
	cr: function(){
		if(!arguments[0]){
			throw("Don't set Tag name");
		}
		var EL = document.createElement(arguments[0]);
		for(var i = 1, m = arguments.length; i < m; i += 2){
			arguments[i] && arguments[i + 1] && (EL[arguments[i]] = arguments[i + 1]);
		}
		return EL;
	},
	// Set styles to Html Element
	// @param {HTMLElement,String, String, ...} - First is Element Node, next coma separated property-name, property-values
	st: function(){
		if(!(arguments[0] && arguments[0] instanceof HTMLElement)){
			throw('Arguments must be instanceof HtmlElement');
		}
		var EL = arguments[0];
		for(var i = 1, m =arguments.length; i < m; i += 2){
			arguments[i] && (EL.style[arguments[i]] = arguments[i + 1] || "");
		}
	},
	// DEPRICATED
	// Finds child elements in node by css selector:
	// @param {Node} node
	// @param {String} selector -ccss selector
	// @param {Bool} getAll - get all results or first related
	// @return {Bool|NodeList|Node}
	fnd: function(node, selector, getAll){
		var method = getAll ? "querySelectorAll" : "querySelector";
		return node && node[method] && node[method](selector);
	},
	// slector api
	// @param {Node} node
	// @param {String} selector -ccss selector
	// @param {Bool} getAll - get all results or first related
	// @return {NodeList|Node}
	select: function(selector, getAll, node){
		return (node || document)[getAll ? "querySelectorAll" : "querySelector"](selector);
	},
	emptyNode: function(node){
		var childNodes = node.childNodes;
		for(i = childNodes.length; i--;){
			node.removeChild(childNodes[i]);
		}
	},
	removeNode: function(node){
		node && node.parentNode && node.parentNode.removeChild(node);
	},
	// Prepend node
	// @param {Node} parent
	// @param {Node} node
	prepend: function(parent, node){
		if(parent.firstChild){
			parent.insertBefore(node, parent.firstChild);
		}else{
			parent.appendChild(node);
		}
	},
	//
	appendAfter: function(parent, after, node){
		if(after.nextSibling){
		  	parent.insertBefore(node, after.nextSibling);
		}else{
		  	parent.appendChild(node);
		}
	},
	// set Data attribute to node
	// @param {HtmleElement} node
	// @param {String} field 
	// @param {String} value
	setDataValue: function(node,field,value){
		var 	attrField = 'data-' + field.replace(/([A-Z])/g,function(str,p){return '-' + p.toLowerCase();}),
				dataField = field.replace(/-(\w)/g,function(str,p){return p.toUpperCase();});	
		node.dataset[dataField] = value;
		node.setAttribute(attrField,value);
	},
	parentByClass: function(node, className){
		var 	currentNode = node;
		
		while(!currentNode.classList.contains(className) && currentNode != document.body){
			currentNode = currentNode.parentNode;
		}
		
		return currentNode != document.body && currentNode;
	},
	// @return {Bool} true if node is child Of rootNode
	isChildOf: function(node, rootNode){
		var 	currentNode = node;
		
		while(currentNode != rootNode && currentNode != document.body){
			currentNode = currentNode.parentNode;
		}
		
		return currentNode != document.body;
	},

	findLinkByHref: function(href){
		var 	$links = document.links;
		
		for(var i = 0; i < $links.length; i++){
			if($links[i].href == href){
				return $links[i];
			}
		}
	},
	css: function($n, o){
		for(var key in o) if(o.hasOwnProperty(key)){$n.style[key] = o[key];}
		return $n;
	},
	getStyle: function(elem, name){ 
	    if (elem.style && elem.style[name]) {
			return elem.style[name]; 
		}else if (document.defaultView && document.defaultView.getComputedStyle) { // Или методом W3C, если он существует 
			// 'textAlign' -> 'text-align' 
			name = name.replace(/([A-Z])/g, "-$1").toLowerCase(); 
			var s = document.defaultView.getComputedStyle(elem, ""); 
			return s && s.getPropertyValue(name); 
		}else if (elem.currentStyle && elem.currentStyle[name]){ // IE fix
			return elem.currentStyle[name]; 
	    }else{ 
	       return null; 
		}
	}, 
};

{
	function log2(){
		var 	str = arguments[0] || '',
				parts = str.split('%s'),
				counter = parts.length - 1;
				list = [parts[counter]];

		while(counter-- > 0){
			list.unshift(parts[counter] + (arguments[counter + 1] || '%s'));
		}
		
		return list.join('');
	}
	function getOffsetRect(elem) {
		var 	box = elem.getBoundingClientRect(),
				body = document.body,
				docElem = document.documentElement;

		var 	scrollTop = window.pageYOffset || docElem.scrollTop || body.scrollTop,
				scrollLeft = window.pageXOffset || docElem.scrollLeft || body.scrollLeft,
				clientTop = docElem.clientTop || body.clientTop || 0,
				clientLeft = docElem.clientLeft || body.clientLeft || 0;

		return { 
			top: Math.round(box.top +  scrollTop - clientTop), 
			left: Math.round(box.left + scrollLeft - clientLeft),
			boxTop: box.top,
			boxLeft: box.left,
			width: box.width,
			height: box.height,
		};
	}

	function PopupView(iframe, link, taskId){
		this.id = taskId;
		this.el = iframe;

		this.controls = {
			doc: $4.cr('x-html'),
			body: $4.cr('x-body'),
			bubble: $4.cr('x-bubble'),
			close: $4.cr('x-close'),
			title: $4.cr('x-title'),
			wrap: $4.cr('x-wrap'),
			// table: $4.cr('table'),
			content: $4.cr('x-table'),
			logo: $4.cr('x-logo'),
			arrow: $4.cr('x-arrow'),
			arrowInner: $4.cr('x-arrow-inner'),
		};
		// this.controls.table.appendChild(this.controls.content);
		this.controls.wrap.appendChild(this.controls.content);
		this.controls.bubble.appendChild(this.controls.close);
		this.controls.bubble.appendChild(this.controls.title);
		this.controls.bubble.appendChild(this.controls.wrap);
		this.controls.bubble.appendChild(this.controls.logo);
		this.controls.body.appendChild(this.controls.bubble);
		this.controls.body.appendChild(this.controls.arrow);
		this.controls.body.appendChild(this.controls.arrowInner);
		this.controls.doc.appendChild(this.controls.body);
		this.el.appendChild(this.controls.doc);

		$4.css(this.controls.doc, {
			display: 'table',
			width: '100%',
			height: '100%',
			fontFamily: 'Arial',
		});
		$4.css(this.controls.close, {
			position: 'absolute',
			width: '16px',
			height: '16px',
			top: '8px',
			right: '8px',
			background:  'url(' + SPRITE + ') -1px -1px no-repeat',
			cursor: 'pointer',
		}).onclick = function(){
			this.close();
		}.bind(this);
		$4.css(this.controls.body, {
			display: 'table-cell',
			position: 'relative',
			// display: 'block',
			// height: '100%',
			width: '100%',
			margin: 0,
			padding: '2px 0',
			boxSizing: 'border-box',
		});
		$4.css(this.controls.bubble, {
			display: 'block',
			position: 'relative',
			border: '1px solid #b2b2b2',
			borderRadius: '2px',
			background: '#fff',
			boxShadow: 'rgba(0, 0, 0, 0.2) 0px 2px 6px',
			width: '100%',
			height: '100%',
			boxSizing: 'border-box',
			padding: '48px 12px 32px 18px',
			overflow: 'hidden',
		});
		$4.css(this.controls.wrap, {
			display: 'block',
			width: '100%',
			maxHeight: '80px',
			overflowY: 'auto',
		});
		$4.css(this.controls.title, {
			display: 'block',
			position: 'absolute',
			left: '20px',
			top: '22px',
			right: '40px',
			fontWeight: 'normal',
			margin: 0,
			padding: '0 0 0 22px',
			fontSize: '14px',
			lineHeight: '14px',
			background: 'url(' + PRELOADER + ') 0 0 no-repeat',
			backgroundSize: '16px 16px',
		}).textContent = _['ctx_please_wait'];
		$4.css(this.controls.content, {
			display: 'table',
			width: '100%',
			borderCollapse: 'collapse',
			fontSize: '12px',
			lineHeight: '20px',
			color: '#6f6f6f',
			verticalAlign: 'top',
		});
		$4.css(this.controls.arrow, {
			position: 'absolute',
			display: 'block',
			width: 0,
			height: 0,
			border: '11px solid transparent'
		});
		$4.css(this.controls.arrowInner, {
			position: 'absolute',
			display: 'block',
			width: 0,
			height: 0,
			border: '10px solid transparent'
		});
		$4.css(this.controls.logo, {
			display: 'block',
			position: 'absolute',
			background:  'url(' + SPRITE + ') -1px -35px no-repeat',
			right: '17px',
			bottom: '11px',
			width: '78px',
			height: '15px',
		});
		this.addLink(_['ctx_link'], link);
	};
	// close current
	PopupView.prototype.close = function(){
		var 	stack = this.constructor._stack,
				root = stack[this.id].el;

		if(root){
			root.parentNode.removeChild(root);
			delete stack[this.id];
		}
	}
	PopupView.prototype.addRow = function(label, value, isFirst){
		var 	$tr = $4.cr('x-tr'),
				$label = $4.cr('x-td', 'textContent', label),
				$value = $4.cr('x-td');

		$label.style.padding = '0 5px 0 0';
		$label.style.color = '#9e9e9e';
		$label.style.display = $value.style.display = 'table-cell';
		$label.style.whiteSpace = 'nowrap';
		$value.style.width = '100%';
		$value.style.padding = '0';
		$tr.style.display = 'table-row'; 
		$tr.appendChild($label);
		$tr.appendChild($value);

		if(value){
			$value.textContent = value;			
		}

		if(isFirst){
			$4.prepend(this.controls.content, $tr);
		}else{
			this.controls.content.appendChild($tr);	
		}
		
		return $value;
	};
	PopupView.prototype.addLink = function(label, value){
		var 	$tr = $4.cr('x-tr'),
				$label = $4.cr('x-td', 'textContent', label),
				$node = $4.cr('div', 'textContent', value),
				$value = $4.cr('x-td');

		$label.style.padding = '0 5px 0 0';
		$label.style.color = '#9e9e9e';
		$label.style.whiteSpace = 'nowrap';
		$value.style.position = 'relative';
		$value.style.padding = '0';
		$value.style.width = '100%';
		$label.style.display = $value.style.display = 'table-cell';
		$4.css($node, {
			position: 'absolute',
			left: 0,
			top: 0,
			bottom: 0,
			right: 0,
			wordBreak: 'break-all',
			textOverflow: 'ellipsis',
			whiteSpace: 'nowrap',
			overflow: 'hidden',
			cursor: 'pointer',
		}).onclick = function(e){
			var style = e.target.style;

			if(style.position == 'absolute'){
				style.position = '';
				style.whiteSpace = '';
			}else{
				style.position = 'absolute';
				style.whiteSpace = 'nowrap';
			}
		}

		$value.appendChild($node);
		$tr.style.display = 'table-row'; 
		$tr.appendChild($label);
		$tr.appendChild($value);
		this.controls.content.appendChild($tr);	
		return $node;
	};
	PopupView.prototype.POPUP_X_OFFSET = 8;
	PopupView.prototype.VERT_OFFSET = 14;
	PopupView._stack = {};
	PopupView.closeAll = function(){
		var 	stack = this._stack,
				taskId,
				root;
		
		for(taskId in stack){
			root = stack[taskId].el;
			root.parentNode.removeChild(root);
			delete stack[taskId];
		}
	};
	PopupView.create = function($a, link, taskId){
		var 	rect2 = getOffsetRect($a),
				frag = document.createDocumentFragment(),
				popupFrame = $4.cr('x-frame'),
				width = 434,
				height = 184,
				left = rect2.left,
				vertPos, horPos,
				popupFrameStyles = {
					display: 'block',
					position: 'absolute',
					float: 'none',
					flex: 'none',
					borderRadius: '2px',
					visibility: 'visible',
					zIndex: 10000,
					background: 'transparent',
					border: 'none',
					width: width + 'px', 
					height: height + 'px',
				},
				popup = new PopupView(popupFrame, link, taskId);

		frag.appendChild(popupFrame);
		PopupView._stack[taskId] = popup;

		if(rect2.boxTop > height){ // Top
			popupFrameStyles.top = rect2.top - height + 'px';
			vertPos = true; 
		}else{ // Bottom
			popupFrameStyles.top = rect2.top + rect2.height + 'px';
		}

		if(document.documentElement.clientWidth - rect2.boxLeft - rect2.width < width){ // Not enough space, right from the link
			horPos = true;
			popupFrameStyles.left = left + rect2.width + PopupView.prototype.POPUP_X_OFFSET - width + 'px';
		}else{
			popupFrameStyles.left = left -  PopupView.prototype.POPUP_X_OFFSET + 'px';
		}
		$4.css(popupFrame, popupFrameStyles);
		popupFrame.onclick = function(e){e.stopPropagation();};
		// popupFrame.oncontextmenu = function(e){e.stopPropagation();};

		popup.controls.arrow.style[vertPos ? 'bottom' : 'top'] = '4px';
		popup.controls.arrow.style[vertPos ? 'borderBottomWidth' : 'borderTopWidth'] = 0;
		popup.controls.arrow.style[vertPos ? 'borderTopColor' : 'borderBottomColor'] = '#b2b2b2';
		popup.controls.arrowInner.style[vertPos ? 'bottom' : 'top'] = '5px';
		popup.controls.arrowInner.style[vertPos ? 'borderBottomWidth' : 'borderTopWidth'] = 0;
		popup.controls.arrowInner.style[vertPos ? 'borderTopColor' : 'borderBottomColor'] = '#fff';
		popup.controls.arrow.style[horPos ? 'right': 'left'] = '24px';
		popup.controls.arrowInner.style[horPos ? 'right': 'left'] = '25px';
		popup.controls.body.style[vertPos? 'paddingBottom' : 'paddingTop'] = PopupView.prototype.VERT_OFFSET + 'px';
		popup.controls.body.style.verticalAlign = vertPos ? 'bottom' : 'top';
		document.documentElement.appendChild(frag);
	};
}

var 	PRELOADER = self.options.spiner,
		SPRITE = self.options.sprite,
		_ = self.options.vocabulary;

// close popup if click out of popup
document.addEventListener('click', function(e){
	PopupView.closeAll();
	self.port.emit('destroy');
});

self.port.on('initialize', function(conf){
	var node = document.querySelector('.' + conf.selector); 

	if (node.href) {
		PopupView.closeAll();
		PopupView.create(node, node.href, conf.taskId);
		node.classList.remove(conf.selector);
	} else {
		console.warn('Link not found');
	}
})

self.port.on('ip', function(ip, taskId){
	var popup = PopupView._stack[taskId];

	if(popup){
		popup.addRow(_['ctx_ip'], ip);
	}
});
self.port.on('redirect', function(url, taskId){
	var popup = PopupView._stack[taskId];

	if(popup){
		popup.addLink(_['ctx_redirect'], url);
	}
});
self.port.on('error', function(report){
	var popup = PopupView._stack[report.taskId];

	if(popup){
		// popup.addRow(_['ctx_error'], _['ctx_cant_check_link']);	
		popup.controls.title.textContent =  _['ctx_cant_check_link'];
		popup.controls.title.style.color = '#6f6f6f';
		popup.controls.title.style.background = 'url(' + SPRITE + ') -1px -91px no-repeat';
	}
});

var categorizeHandler = function(report){
	var popup = PopupView._stack[report.taskId];

	if(popup){
		if (Array.isArray(report.categories) && report.categories.length > 0) {
			if(!popup.controls.category){
				popup.controls.category = popup.addRow(_['ctx_category']);
			}
			popup.controls.category.textContent = report.categories.join(', ');
			popup.controls.title.textContent =  _['ctx_not_recommended'];
			popup.controls.title.style.color = '#e95c30';
			popup.controls.title.style.background = 'url(' + SPRITE + ') 0 -74px no-repeat';
			popup._detected = true;
		}else{ // not threated
			// popup.controls.title.textContent =  _['ctx_threats_not_found'];
			// popup.controls.title.style.color = '#61ab00';
			// popup.controls.title.style.background = 'url(' + SPRITE + ') 0 -57px no-repeat';
		}
		
		report.legalUrl && popup.addRow(_['ctx_owner'], report.legalUrl);
	}
};
self.port.on('ipCheck', categorizeHandler);
self.port.on('urlCheck', categorizeHandler);
self.port.on('fileCheck', function(virName, taskId){
	var popup = PopupView._stack[taskId];

	if(popup && virName){
		popup.addRow(_['ctx_threat'], virName, true);
		popup.controls.title.textContent =  _['ctx_not_recommended'];
		popup.controls.title.style.color = '#e95c30';
		popup.controls.title.style.background = 'url(' + SPRITE + ') 0 -74px no-repeat';
	}else if(popup && !popup._detected){
		popup.controls.title.textContent =  _['ctx_threats_not_found'];
		popup.controls.title.style.color = '#61ab00';
		popup.controls.title.style.background = 'url(' + SPRITE + ') 0 -57px no-repeat';
	}
});
self.port.on('gate', function(taskId){
	var popup = PopupView._stack[taskId];

	if(popup){
		popup.controls.title.textContent =  _['ctx_blocked_by_spider_gate'];
		popup.controls.title.style.color = '#e95c30';
		popup.controls.title.style.background = 'url(' + SPRITE + ') 0 -74px no-repeat';
	}
})

window.addEventListener('message', function(e){
	var data;

	try{
		data = JSON.parse(e.data);
	}catch(err){} // message in another format
	
	if(data && data.action == 'update_host'){
		var 	host = window.location.protocol + '//' + window.location.host;

		self.port.emit('update_host', host);
		window.postMessage(JSON.stringify({
			action: 'access'
		}), host);	
	}
}, false);
