var 	_HOST = window.location.host.replace(/^www\./i, ''),
		HOST_COLLECTION = {
			'google.ru': 'google',
			'google.com': 'google',
			'yandex.ru': 'yandex',
			'yandex.com': 'ynadex',
			'search.yahoo.com': 'yahoo',
			'go.mail.ru': 'mail_ru',
			'nova.rambler.ru': 'rambler'
		},
		MARK_CLASS = 'lc_mark_' + ~~(Math.random() * 1000),
		THREAT_SRC = self.options.threat;
		LOGO_SRC = self.options.spider;
		BLOCK_CLASS = 'lc_removed-serp-items',
		WARN_CLASS = 'lc_removed-serp-warnings',
		_ = self.options.vocabulary;

var $4m = {
	// @param {string} text
	// @return {TextNode}
	t: function(text){
		return document.createTextNode(text);
	},
	// Create new HTML Element with options
	// @param {_} - First is Tag name <) console.dir($4.cr("option","value","email","textContent","Hello")); 
	// @return {HTMLElement}
	cr: function(){
		var EL = document.createElement(arguments[0]);
		for(var i = 1, m = arguments.length; i < m; i += 2){
			arguments[i] && arguments[i + 1] && (EL[arguments[i]] = arguments[i + 1]);
		}
		return EL;
	},
	// Set styles to Html Element
	// @param {HTMLElement,String, String, ...} - First is Element Node, next coma separated property-name, property-values
	st: function(){
		var EL = arguments[0];
		for(var i = 1, m = arguments.length; i < m; i += 2){
			arguments[i] && (EL.style[arguments[i]] = arguments[i + 1] || "");
		}
		return EL;
	},
	// slector api
	// @param {Node} node
	// @param {String} selector -ccss selector
	// @param {Bool} getAll - get all results or first related
	// @return {NodeList|Node}
	select: function(selector, getAll, node){
		return (node || document)[getAll ? "querySelectorAll" : "querySelector"](selector);
	},
	css: function($n, o){
		for(var key in o) if(o.hasOwnProperty(key)){$n.style[key] = o[key];}
		return $n;
	},
	// @memberOf $4 - parse selector string
	// @param {HtmlElement} node
	// @return {Object}
	_parseSel: function(selector){
		var 	parts = selector.split(/(#|\.)/g),
				pos = 0,
				res = {cls: [], id: '', tagName: ''};
		
		if(parts[pos] != '#' && parts[pos] != '.'){
			res.tagName = parts[pos].toUpperCase();
			pos++;
		}
		for(; pos < parts.length; pos += 2){
			if(parts[pos] == '#'){
				res.id = parts[pos + 1];
			}else{
				res.cls.push(parts[pos + 1]);
			}
		}
		return res;
	},
	// @memberOf $4
	// @param {HtmlElement} node
	// @param {String} selector
	// @return {HtmlElement|undefined}
	closest: function(node, selector){
		var 	conf = this._parseSel(selector),
				currentNode = node, 
				fail;
		
		// while(currentNode != document.body){
		while(currentNode.parentNode != undefined){
			if(conf.id && currentNode.id != conf.id){
				currentNode = currentNode.parentNode;
				continue;
			}

			if(conf.tagName && currentNode.tagName != conf.tagName){
				currentNode = currentNode.parentNode;
				continue;
			}

			if(conf.cls.length){
				fail = false;
				for(var i = 0; i < conf.cls.length; i++){
					if(!currentNode.classList.contains(conf.cls[i])){
						fail = true;
					}
				}
				if(fail){
					currentNode = currentNode.parentNode;
					continue;
				}
			}
			
			return currentNode;
		}
		return undefined;
	},
	empty: function(node){
		var childNodes = node.childNodes;
		for(i = childNodes.length; i--;){
			node.removeChild(childNodes[i]);
		}
	},
};

function plural(a, form1, form2, form3){
	if ( a % 10 == 1 && a % 100 != 11 ) return form1;
	else if ( a % 10 >= 2 && a % 10 <= 4 && ( a % 100 < 10 || a % 100 >= 20)) return form2;
	else return form3;
};
function convertToFragment(str, map){
	var 	pos = 0,
			_out = document.createDocumentFragment();

	str.replace(/%([^%]+)%|{{([^\}]+)}}/g, function(pattern, variable, link, offset){
		if(variable){
			if(map && map[variable] != undefined){
				_out.appendChild(document.createTextNode(str.substring(pos, offset)));
				_out.appendChild(document.createTextNode(map[variable]));
			}else{
				_out.appendChild(document.createTextNode(str.substring(pos, offset + pattern.length)));
			}
			pos = offset + pattern.length;
		}else if(link){
			_out.appendChild(document.createTextNode(str.substring(pos, offset)));
			var $link = document.createElement('a');
			$link.textContent = link;
			_out.appendChild($link);
			pos = offset + pattern.length;
		}
	});
	_out.appendChild(document.createTextNode(str.substring(pos)));
	return _out;
}
// @param {HtmlElement} $serpList - serp items list node
function getRemovedItemsWrap($serpList, count, alertHook){
	var 	$curRemovedWrap = $serpList.querySelector('.' + BLOCK_CLASS);
	var		$warning = $curRemovedWrap && $curRemovedWrap.querySelector('.' + WARN_CLASS);

	if(!$curRemovedWrap){
		var 	$warnAllert = $4m.css($4m.cr('x-div'), {
					display: 'block',
					padding: '0 0 0 32px',
					radius: '1px',
					color: '#545454',
					fontSize: '12px',
					lineHeight: '20px',
					margin: '0 0 20px 0',
					background: 'url(' + LOGO_SRC + ') #61ab00 2px 10px no-repeat',
				}),
				$inner = $4m.css($4m.cr('x-div'), {
					border: '1px solid #d8d8d8',
					borderLeft: 'none',
					display: 'block',
					padding: '12px 18px',
					background: '#fff',
				}),
				$warning = $4m.cr('div', 'className', WARN_CLASS),
				$curRemovedWrap = $4m.cr('div', 'className', BLOCK_CLASS);

		$4m.st($warning, 'marginRight', '6px');
		$inner.appendChild($warning);
		$warnAllert.appendChild($inner);
		$curRemovedWrap.appendChild($warnAllert);
		alertHook && alertHook($warnAllert, $inner);
		$serpList.appendChild($curRemovedWrap);
	}
	//---------------------------
	var $frag = convertToFragment(_['serp_removed_messages'], {
		count: (count + ' ' + _[plural(count, 'serp_result1', 'serp_result2', 'serp_result5')])
	});

	if($frag.children[0]){
		$frag.children[0].href = '#';
		$frag.children[0].onclick = function(e){
			e.stopPropagation();
			e.preventDefault();

			var 	$warning = e.target.parentNode.parentNode.parentNode,
					$root = $warning.parentNode, 
					i;

			$root.removeChild($warning);
			i = $curRemovedWrap.childNodes.length;

			while(i-- > 0){
				$root.childNodes[i].style.display = '';
			}
		};
	}
	$4m.empty($warning);
	$warning.appendChild($frag);
	return $curRemovedWrap;
}

var SearchSystemProvider = {
	google: {
		selector: '.rc>.r>a',
		getLink: function($a){
			return $a.dataset.href || $a.href;
		},
		addWarning: function($a, categories){
			var 	$serpItemRoot = $a.parentNode.parentNode.parentNode,
					$linkLabel = $serpItemRoot.querySelector('.f.kv._SWb'),
					$cite = $linkLabel && $linkLabel.querySelector('._Rm'),
					$arrow = $linkLabel && $linkLabel.querySelector('.mn-dwn-arw');

			if($linkLabel){
				$linkLabel.style.color = '#de2b09';
				$linkLabel.style.paddingLeft = '12px';
				$linkLabel.style.background = 'url(' + THREAT_SRC + ') 0 2px no-repeat';
				$linkLabel.setAttribute('title', categories);
				
				if($cite){
					$cite.style.color = 'inherit';
				}
				if($arrow){
					$arrow.style.borderColor = '#de2b09 transparent';
				}
			}

			$serpItemRoot.style.display = 'none';
			$serpItemRoot.classList.add('g');
			return $serpItemRoot;
		},
		getSLN: function(){
			return document.querySelector('#ires');
		}
	},
	yandex: {
		selector: '.serp-item__title-link',
		getLink: function($a){
			return $a.href;
		},
		addWarning: function($a, categories){
			var 	$root = $4m.closest($a, '.serp-item'), 
					$linkLabel = $root.querySelector('.serp-url'),
					$cites = $linkLabel && $linkLabel.querySelectorAll('.serp-url__link');

			if($linkLabel){
				$linkLabel.style.color = '#de2b09';
				$linkLabel.style.paddingLeft = '12px';
				$linkLabel.style.background = 'url(' + THREAT_SRC + ') 0 2px no-repeat';
				$linkLabel.setAttribute('title', categories);
				
				if($cites){
					for(var i = 0; i < $cites.length; i++){
						$cites[i].style.color = 'inherit';
					}
				}
			}

			$root.style.display = 'none';
			return $root;
		},
		getSLN: function(){ /*Serp List Node*/
			return document.querySelector('.serp-list[role=main]');
		}
	},
	yahoo: {
		selector: '.compTitle>.title>a',
		getLink: function($a){
			var 	link = $a.href,
					buf = link.split(/\/|=/),
					pos = buf.indexOf('RU');

			if(pos != -1){
				link = decodeURIComponent(buf[pos + 1]);
			}

			return link;
		},
		addWarning: function($a, categories){
			var 	$root = $a.parentNode.parentNode.parentNode.parentNode,
					$linkLabel = $a.parentNode.nextElementSibling || $a.parentNode.parentNode.nextElementSibling,
					$cites = $linkLabel && $linkLabel.querySelectorAll('.cite,.sep');

			if($linkLabel){
				$linkLabel.style.color = '#de2b09';
				$linkLabel.style.paddingLeft = '12px';
				$linkLabel.style.background = 'url(' + THREAT_SRC + ') 0 2px no-repeat';
				$linkLabel.setAttribute('title', categories);
				$linkLabel.children[0].style.color = 'inherit';

				if($cites){
					for(var i = 0; i < $cites.length; i++){
						$cites[i].style.color = 'inherit';
					}
				}
			}

			$root.classList.remove('first');
			$root.style.display = 'none';
			return $root;
		},
		getSLN: function(){
			return document.querySelector('.searchCenterMiddle');
		},
		alertHook: function($warnAlert){
			$warnAlert.style.margin = '20px 10px 0';
		}
	},
	mail_ru: {
		selector: '.result__title>.light-link',
		getLink: function($a){
			return $a.href;
		},
		addWarning: function($a, categories){
			var 	$root = $a.parentNode.parentNode,
					$linkLabel = $a.parentNode.nextElementSibling,
					$cites = $linkLabel && $linkLabel.querySelectorAll('.block-info-serp__link');

			if($linkLabel){
				$linkLabel.style.color = '#de2b09';
				$linkLabel.style.paddingLeft = '12px';
				$linkLabel.style.background = 'url(' + THREAT_SRC + ') 0 2px no-repeat';
				$linkLabel.setAttribute('title', categories);
				
				if($cites){
					for(var i = 0; i < $cites.length; i++){
						$cites[i].style.color = 'inherit';
					}
				}
			}

			$root.style.display = 'none';
			return $root;
		},
		getSLN: function(){
			return document.querySelector('.result');
		}
	},
	rambler: {
		selector: '.b-serp-item__link',
		getLink: function($a){
			return $a.href;
		},
		addWarning: function($a, categories, count){
			var 	$root = $a.parentNode.parentNode.parentNode,
					$linkLabel = $root.querySelector('.b-serp-item__info');

			if($linkLabel){
				$linkLabel.style.color = '#de2b09';
				$linkLabel.style.paddingLeft = '12px';
				$linkLabel.style.background = 'url(' + THREAT_SRC + ') 0 2px no-repeat';
				$linkLabel.setAttribute('title', categories);
			}

			$root.style.display = 'none';
			return $root;
		},
		getSLN: function(){
			var list = document.querySelectorAll('.b-serp-list');
			return list[list.length - 1];
		}, 		
		alertHook: function($warnAlert, $inner){
			$inner.classList.add('b-serp-item__snippet');
			$inner.classList.add('b-serp-item');
		}
	}
};

var 	_curProvider = SearchSystemProvider[HOST_COLLECTION[_HOST]],
		_linkCollection = {};

var observer = new MutationObserver(function(mutations){
	var 	$links = document.querySelectorAll(_curProvider.selector),
			linkList = [];

	if(!$links || !$links.length) return;
	_linkCollection = {};

	for(var i = 0, len = $links.length, href; i < len; i++){
		href = _curProvider.getLink($links[i]);
		_linkCollection[href] = $links[i];

		if(!$links[i].classList.contains(MARK_CLASS)){
			$links[i].classList.add(MARK_CLASS);
			linkList.push(href);
		}
	}

	if(linkList.length > 0){
		self.port.emit('check_links', linkList);
	}
});

// observer.disconnect();
observer.observe(document, {
	// attributes: true, // strangely important
	childList: true, 
	subtree: true 
});

// receiving messages from background
self.port.on('hide_link', function(resp){
	var 	$serpList = _curProvider.getSLN(),
			$remItemsWrap;

	if (resp.categories > 0 && _linkCollection[resp.href]) {
		$remItemsWrap = getRemovedItemsWrap($serpList, resp.count, _curProvider.alertHook);
		$remItemsWrap.appendChild(_curProvider.addWarning(_linkCollection[resp.href], resp.category));
	}
});
