var _CAT_LIST = {
	UC_INFECTION_SOURCE: 0x10,
	UC_NOT_RECOMMENDED: 0x20,
	UC_ADULT_CONTENT: 0x40,
	UC_VIOLENCE: 0x80,
	UC_WEAPONS: 0x100,
	UC_GAMBLING: 0x200,
	UC_DRUGS: 0x400,
	UC_OBSCENE_LANGUAGE: 0x800,
	UC_CHATS: 0x1000,
	UC_TERRORISM: 0x2000,
	UC_FREE_EMAIL: 0x4000,
	UC_SOCIAL_NETWORKS: 0x8000,
	UC_OWNERS_NOTICE: 0x10000,
	UC_BLACK_LIST: 0x20000
};

function fromRfc3986(val){
	var 	tmp = val
			.replace(/%21/g, "!")
			.replace(/%2A/g, "*")
			.replace(/%27/g, "'")
			.replace(/%28/g, "(")
			.replace(/%29/g, ")");

	return decodeURIComponent(tmp);
};
function formDecode(encoded){
	var 	params = encoded.split("&"),
			decoded = {},
			keyval,
			key,
			val;

	for (var i = 0, param; param = params[i]; i++) {
		keyval = param.split("=");
		if (keyval.length == 2) {
			key = fromRfc3986(keyval[0]);
			val = fromRfc3986(keyval[1]);
			decoded[key] = val;
		}
	}
	return decoded;
};
function w0(num){
	return (num < 10 ? '0' : '') + num;
}
function clearUrl(url){
	if(url.indexOf('http://') == 0){
		return url.replace(':80/', '/');
	}else if(url.indexOf('https://') == 0){
		return url.replace(':443/', '/');
	}else{
		return url;
	}
}

var 	search = window.location.search.substr(1),
		conf = formDecode(search),
		cat = parseInt(conf.cat || 0),
		categories = [],
		$original = document.getElementById('original'),
		$btn  = document.getElementById('btn'),
		$cat  = document.getElementById('cat'),
		$time = document.getElementById('time'),
		$blockReason = document.getElementById('block-reason'),
		$troubleMes = document.getElementById('trouble-mes'),
		$ownerTr = document.getElementById('owner_tr'),
		$owner = document.getElementById('owner'),
		now = new Date();

for(var key in _CAT_LIST){
	if(_CAT_LIST.hasOwnProperty(key) && (cat & _CAT_LIST[key])){
		categories.push(self.options[key]);
	}
}

$time.textContent = w0(now.getDate()) + '.' + w0(now.getMonth() + 1) + '.' + now.getFullYear() + ' ' + w0(now.getHours()) + ':' + w0(now.getMinutes());
$original.textContent = clearUrl(conf.protocol + '://' + conf.original);

if (!conf.cat) {
	$blockReason.style.display = 'none';
	$troubleMes.style.display = '';
} else {
	$cat.textContent = categories.join(', ');	
}

if (conf.owner) {
	$owner.textContent = conf.owner;
	$ownerTr.style.display = '';
}
$btn.addEventListener('click', function(e){
	var host = decodeURIComponent(conf.original).split('/')[0].replace(/^www\./i, '');
	self.port.emit('skip_host', host);
});

self.port.on('reload_page', function(){
	window.location.href = conf.protocol + '://' + decodeURIComponent(conf.original);
});
function INN(voc){
	var 	nodes = document.querySelectorAll('[data-i18n]'),
			len = nodes.length,
			key, attr, pos;

	while(len--){
		key = nodes[len] && nodes[len].dataset.i18n;
		if(key === undefined) continue;
		pos = key.indexOf(':');
		
		if(pos != -1){
			attr = key.substr(0, pos);
			key = key.substr(pos + 1);
			voc[key] != undefined && nodes[len].setAttribute(attr, voc[key]);
		}else if(voc[key] != undefined){
			nodes[len].textContent = voc[key];
		}
	}
}
INN(self.options);