var $4 = {
	// Create new HTML Element with options
	// @param {_} - First is Tag name <) console.dir($4.cr("option","value","email","textContent","Hello")); 
	// @return {HTMLElement}
	cr: function(){
		var EL = document.createElement(arguments[0]);
		for(var i = 1, m = arguments.length; i < m; i += 2){
			arguments[i] && arguments[i + 1] && (EL[arguments[i]] = arguments[i + 1]);
		}
		return EL;
	},
	emptyNode: function(node){
		var 	childNodes = node.childNodes,
				i = childNodes.length;

		while(i-- > 0){
			node.removeChild(childNodes[i]);
		}
	},
};

var 	_currentHost,
		_DISABLED_CLASS = '__disabled';

function renderDropDownList(wrapNode, listNode, counterNode, items){
	var listLen = items.length;
	
	$4.emptyNode(listNode);
	
	for(var i = 0, item;  item = items[i], i < listLen;  i++){
		listNode.appendChild($4.cr('div', 'className', 'p2_stat-block_item', 'textContent', item.name));
	}
	
	if(listLen == 0){
		wrapNode.classList.add(_DISABLED_CLASS);
	}else{
		wrapNode.classList.remove(_DISABLED_CLASS);
	}
	counterNode.textContent = listLen;
};

function resize(){
	var height = document.body.offsetHeight;
	
	if(height > 600){
		height = 600;
	}
	
	if(height > 0){
		self.port.emit('resize', {
			height: height
		});
	}
};

function onReady(data){
    var     blockedAnalytics = [],
            blockedSocial = [],
            i = data.blocks.length,
            item;

	while(i-- > 0){
		item = data.blocks[i];

		if(item.reason == "Web Analytics"){
            blockedAnalytics.push(item);
        }else if(item.reason == "Social Buttons"){
            blockedSocial.push(item);
        }
	}   
	renderDropDownList(
		document.all.webAnalyticsWrap, 
		document.all.webAnalyticsList, 
		document.all.webAnalyticsCounter,
		blockedAnalytics
	);
	renderDropDownList(
		document.all.socialWrap, 
		document.all.socialList, 
		document.all.socialCounter,
		blockedSocial
	);
		
	document.all.selectAds.value = data.adsValue;
	document.all.selectFlash.value = data.flashValue;
		
	if(data.flashEnabled){
		document.all.flashDefaultDeny.style.display = '';
		document.all.flashDefaultAllow.style.display = 'none';
	}else{
		document.all.flashDefaultDeny.style.display = 'none';
		document.all.flashDefaultAllow.style.display = '';
	}

	if(data.adsEnabled){
		document.all.adsDefaultDeny.style.display = '';
		document.all.adsDefaultAllow.style.display = 'none';
	}else{
		document.all.adsDefaultDeny.style.display = 'none';
		document.all.adsDefaultAllow.style.display = '';
	}

	document.all.toggleManualBlockBtn.onclick = function(){
		self.port.emit('toggleManualBlock');
	};
	document.all.settingsBtn.onclick = function(){
		self.port.emit('openSettingsPage');	
	};
	document.all.selectFlash.onchange = function(e){
		var value = e.target.value;
		
		if(data.tabHost){ 
			self.port.emit('updateException',{
				host: data.tabHost,
				value: value,
				type: 'flash',
			});
		}
	};
	document.all.selectAds.onchange = function(e){
		var value = e.target.value;
		
		if(data.tabHost){
			self.port.emit('updateException',{
				host: data.tabHost,
				value: value,
				type: 'ads'
			});
		}
	};
	document.all.social.onchange = resize;
	document.all.analytics.onchange = resize;
	document.all.social.checked = false;
	document.all.analytics.checked = false;

	// console.log('[Title:] ' + self.options.option_title + ' typeof: ' + typeof(document.all.toggleManualBlockBtn));
	// console.log(document.all.toggleManualBlockBtn);
	// document.all.toggleManualBlockBtn.setAttribute('title', self.options.blocking_title);
	// document.all.settingsBtn.setAttribute('title', self.options.option_title);
}

self.port.on('refreshBlocks', onReady);
self.port.on('show', function() {
	self.port.emit('popupReady', {});
});

