const 	{Cc, Cu, Ci, Cr } = require('chrome');
Cu.import("resource://gre/modules/Services.jsm");

var 	self = require('sdk/self'),
	 	$timers = require("sdk/timers"), // Not used
	 	$simplePrefs = require("sdk/simple-prefs"),
	 	$pref = $simplePrefs.prefs,
		$wc = require('./lib/wc_api'),
	 	requestMachine = require('./lib/request_machine.js'),
		$d = require('./lib/debug.js'),
		$context = require('./lib/context.js'),
		$storage = require("sdk/simple-storage").storage,
		$optionDialog = require('./lib/option_dialog'),
		$wizardDialog = require('./lib/wizard_dialog'),
		$settingsApi = require('./lib/settings_api'),
		_checkTimeout;

require('./lib/popup_dialog.js').init();
require('./lib/tab_manager.js').init();
require('./lib/worker_manager.js').init();
$optionDialog.init();
$wizardDialog.init();
$wc.client.setHost($pref.host);
// $simplePrefs.on('host', function(){});
		
require('./lib/warning_dialog.js').init();
require('./lib/serp.js').init();

// @param {String} loadRason: 'install', 'enable'
exports.main = function(opt){
	Services.obs.addObserver(requestMachine.httpRequestObserver, "http-on-modify-request", false);

	if(opt.loadReason == 'install'){
		$timers.setTimeout(function(){
			$wizardDialog.open();
		}, 1000);
	}
};
// @param {String} reason 'disable'
exports.onUnload = function(reason){
	Services.obs.removeObserver(requestMachine.httpRequestObserver, "http-on-modify-request");
	
	if(reason == 'uninstall'){
		$simplePrefs.preference = null;
		$storage = {};
	}
}

////////////////////////////////////////////////////////////
// set default settings:
////////////////////////////////////////////////////////////
$settingsApi.initDefaultPreference();

////////////////////////////////////////////////////////////
// init db:
////////////////////////////////////////////////////////////
require('./lib/base_manager.js').init();

