var 	$tabs = require("sdk/tabs"),
		$data = require("sdk/self").data,
		 _ = require("sdk/l10n").get;
var		$windows = require("sdk/windows").browserWindows,
		_loginWindow,
		_handlers = [],
		_authStatus;

exports.open = function(cb, wc_client){
	_handlers.push(cb);

	if (_loginWindow) {
		// _wizardTab.window.activate();
		_loginWindow.activate();
	} else {
		_authStatus = false;
		_loginWindow = $windows.open({
			url: $data.url('page/login_page.html'),
			onOpen: function(win) {
				_loginWindow = win;

				if(win.tabs[0]){
					win.tabs[0].on('ready', function(tab){
						var wizardWorker = tab.attach({
							contentScriptFile: $data.url('js/login_page.js'),
							contentScriptOptions: {
								login_title: _('login_title'),
								login_submit: _('login_submit'),
								login_error: _('login_error'),
								login_login: _('login_login'),
								login_password: _('login_password'),
							}
						});
						wizardWorker.port.on('autorize', function(data){
							wc_client.login(data.login, data.pass, function(d, r){
								var code = d && d.error && d.error.code;

								if(d && !code){ // success
									wizardWorker.port.emit('autorize', 0);
									_authStatus = true;
									_loginWindow.close();	
								} else { // fail
									wizardWorker.port.emit('autorize', code || _('login_network-troubles'));
									_authStatus = false;
								}
							});
						});
						wizardWorker.once("detach", function(){
					        wizardWorker.destroy();
					    });
					});
				}
			},
			onClose: function(){
				_loginWindow = undefined;

				// resolve handlers
				var len = _handlers.length;
				while(len--){
					_handlers[len](_authStatus);
				}
				_handlers.length = 0;

			},
		});
	}
}
