var 	MozStorage = require("sdk/simple-storage");

var BlockService = {
	get: function(host){ // maybe unused
		return MozStorage.storage.blockParts ? MozStorage.storage.blockParts[host] : [];
	},
	save: function(host, blocks){
		if(!blocks) return;

		var		rulesCollection = MozStorage.storage.blockParts || {};

		if(!Array.isArray(rulesCollection[host])){
			rulesCollection[host] = [];
		}
		rulesCollection[host] = rulesCollection[host].concat(blocks);
		MozStorage.storage.blockParts = rulesCollection;
	},
	remove: function(host, selector){
		var		rulesCollection = MozStorage.storage.blockParts || {},
				pos;

		if(selector && Array.isArray(rulesCollection[host])){
			pos = rulesCollection[host].indexOf(selector);

			if(pos != -1){
				rulesCollection[host].splice(pos, 1);
			}
		}else{
			delete rulesCollection[host];	
		}

		MozStorage.storage.blockParts = rulesCollection;
	},
	removeRule: function(host, domString){
		var		rulesCollection = MozStorage.storage.blockParts || {};

		if(Array.isArray(rulesCollection[host])){
			var pos = rulesCollection[host].indexOf(domString);

			if(pos != -1){
				rulesCollection[host].splice(pos, 1);
			}
		}
		MozStorage.storage.blockParts = rulesCollection;
	},
	getAdsException: function(host, inFlash){
		if(host){
			var 	list = (!inFlash ? MozStorage.storage.preference.ads_exceptions : MozStorage.storage.preference.flash_exceptions) || [],
					len = list.length;
					
			while(len--){
				if(list[len].baseURL == host){
					return list[len].allow ? 1 : 2;
				}
			}
		}
		
		return  MozStorage.storage.preference[!inFlash ? 'ads_enabled' : 'flash_enabled'] ? 4 : 3;
	}
	
};

exports.blocks = BlockService; 