var 	$pageMod = require("sdk/page-mod").PageMod,
		MozStorage = require('sdk/simple-storage'),
		$url = require('sdk/self').data.url,
		$scanCore = require('./scan_core'),
		CategorizeUrl = $scanCore.CategorizeUrl,
		_ = require("sdk/l10n").get;

exports.init = function(){
	var serpMod = $pageMod({
		include: [
			'*.google.ru',
			'*.google.com',
			'*.search.yahoo.com',
			'*.go.mail.ru',
			'*.nova.rambler.ru',
			/.*yandex\.(ru|com)\/[\w]*search.+/
		],
		attachTo: 'top', //// to main document (not subframes)
		contentScriptFile: $url('js/serp_inject.js'),
		contentScriptWhen: 'start',
		onAttach: function(worker){
			worker.port.on('check_links', function(list){
				var 	count = 0;

				list.forEach(function(href){
					new CategorizeUrl(href, function(next, result){
						result.categories &= ~MozStorage.storage.preference.categories;

						if(result.categories > 0){
							count++;
							result.category = $scanCore.categoryTitle[result.category] || result.category;
							result.href = href;
							result.count = count;
							worker.port.emit('hide_link', result);
						}
					});
				});
			});
		},
		contentScriptOptions: {
			spider: $url('img/spider.png'),
			threat: $url('img/threat_small.png'),
			vocabulary: {
				serp_removed_messages: _('serp_removed_messages'),
				serp_result1: _('serp_result1'),
				serp_result2: _('serp_result2'),
				serp_result5: _('serp_result5'),
			}
		}
	});
}