var		MozStorage = require("sdk/simple-storage"),
		$storage = MozStorage.storage;

exports.updateBlockStatus = function(host, value, type){
	var 	exceptionList = $storage.preference[type == 'flash' ? 'flash_exceptions' : 'ads_exceptions'],
			i = exceptionList.length,
			exceptionItem;
		
	while(i--){
		if(exceptionList[i].baseURL == host){
			exceptionItem = exceptionList[i];
			break;
		}
	}

	if(exceptionItem){ // recently exist
		switch(value){
			case 'allowHere': exceptionItem.allow = true; break;
			case 'denyHere': exceptionItem.allow = false; break;
			default:
				exceptionList.splice(i, 1);
				// for flash can be 'defaultAllow' (don't know why)
				$storage.preference[type == 'flash' ? 'flash_enabled' : 'ads_enabled'] = (value == 'defaultDeny');
		}
	}else{
		if(value == 'allowHere' || value == 'denyHere'){
			// Create new
			$storage.preference[type == 'flash' ? 'flash_exceptions' : 'ads_exceptions'].push({
				id: ("uni" + Math.random()).replace(".", ""),
				baseURL: host,
				allow: value == 'allowHere',
			});
		}else{
			$storage.preference[type == 'flash' ? 'flash_enabled' : 'ads_enabled'] = (value == 'defaultDeny');
		}
	}
};
exports.updatePreferences = function(collection){
	for(key in collection){
		$storage.preference[key] = collection[key];	
	}
};
function allDefined(obj, fieldList){
	var i = fieldList.length;
	while(i--){
		if(obj[fieldList[i]] == undefined){
			return false;
		}
	}
	return true;
}

exports.initDefaultPreference = function(){
	if(	
		!$storage.preference ||
		!allDefined($storage.preference, ['ads_enabled', 'flash_enabled', 'ads_exceptions', 'flash_exceptions', 'analytics_enabled', 'track_enabled', 'social_enabled'/*, 'google_check', 'facebook_check', 'vkontakte_check'*/])
	){
		$storage.preference = {
			ads_enabled: true,
			flash_enabled: false,
			ads_exceptions: [],
			flash_exceptions: [],
			analytics_enabled: true,
			track_enabled: true,
			social_enabled: false,
			categories: 196544,
			// check settings options:
			scan_timeout_ms: 10000,
			heuristic_analysis: true,
			packer_max_level: 8,
			archive_max_level: 8,
			mail_max_level: 8,
			container_max_level: 8,
			max_compression_ratio: 500,
		};
	}
};

exports.isFirstRun = function(){
	return $storage.db || !$storage.updateTimeStamp;
}